local archs = [
  'aarch64-unknown-linux-gnu',
  'aarch64-unknown-linux-musl',
  'x86_64-pc-windows-gnu',
  'x86_64-unknown-linux-gnu',
  'x86_64-unknown-linux-musl',
];

local getStepName(arch) = 'check ' + arch;

local buildForArch(arch) = {
  name: getStepName(arch),
  image: 'rust:1.62',
  commands: [
    'echo Hello World from Jsonnet on ' + arch + '!',
    'pwd',
    'touch ' + arch + '.txt',
    'ls -lah',
    'cargo check',
  ],
};

local check_steps() = [
  buildForArch(a)
  for a in archs
];

{
  kind: 'pipeline',
  type: 'docker',
  name: 'default',
  platform: {
    arch: 'amd64',
  },
  steps:
    check_steps() + [{
      name: 'build',
      image: 'rust:1.62',
      commands: [
        'pwd',
        'ls -lahR',
      ],
      depends_on: [getStepName(a) for a in archs],
    }],
}
